# SimpleRsBLE

The ultimate cross-platform bindings for Bluetooth Low Energy (BLE).

## Overview

SimpleRsBLE provides Rust bindings for [SimpleBLE](https://github.com/OpenBluetoothToolbox/SimpleBLE/),
a fully cross-platform BLE library, designed for simplicity and ease of use, with a consistent behavior and API across all platforms.

**IMPORTANT:** SimpleRsBLE is currently in the process of being rewritten from scratch to follow proper idiomatic Rust patterns.

If you want to use SimpleRsBLE and need help, **please do not hesitate to reach out!**

- Visit our [ReadTheDocs](https://simpleble.readthedocs.io/en/latest/) page for comprehensive documentation
- Visit our [website](https://simpleble.org) or email us at `contact@simpleble.org` for commercial licensing and professional support services
- Join our [Discord](https://discord.gg/N9HqNEcvP3) server for community discussions and help

## Installation

You can add SimpleRsBLE to your project by adding the following lines to your `Cargo.toml`:

```toml
[dependencies]
simplersble = "0.6.0"
```

Please review our [code examples](https://github.com/OpenBluetoothToolbox/SimpleBLE/tree/main/examples/simplersble/src/bin) on GitHub for more information on how to use SimpleRsBLE.

# License

Since February 15th 2024, SimpleBLE is now available under the GNU General Public License version 3 (GPLv3), with the option for a commercial license without the GPLv3 restrictions available for a fee.

**You can find more information on pricing and commercial terms of service on our [website](https://simpleble.org).**

For further enquiries, please contact us at `contact@simpleble.org`.

**We offer free commercial licenses for small projects and early-stage companies - reach out to discuss your use case.**